package catalunya.de.ocells;


import java.util.ArrayList;

import android.app.ActionBar;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CursorAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.SlidingDrawer;
import android.widget.TextView;
import catalunya.de.ocells.CercaInteligentActivity.PropostesAdapter;
import catalunya.de.ocells.cerca.defs;
import catalunya.de.ocells.cerca.preguntes;
import catalunya.de.ocells.db.dbDadesOcellAdapter;
import catalunya.de.ocells.db.dbOcellsAdapter;

public class CercaEscritaActivity extends Activity {
	
	public static final String PREFERENCIA_CERCA_ESCRITA_ORDRE = "cerca_escrita_prefs_ordre_llistes";
	private static final Integer ACTIVITAT_FILTRES_REQUEST_CODE = 1;
	private dbOcellsAdapter mdbOcellsAdapter;
	private LlistaAdapter mLlistaAdapter;
	private FiltresAdapter mFiltresAdapter;
	private ListView lvLlistat, lvFiltres;
	private EditText textCerca;
	public preguntes mPreguntes;
	ArrayList<filtre> filtres;
	

	

  @Override
  public void onCreate(Bundle savedInstanceState) {
      super.onCreate(savedInstanceState);
      
      setContentView(R.layout.activity_cerca_escrita);
      if (android.os.Build.VERSION.SDK_INT >= 11)
    	  getActionBar().setDisplayHomeAsUpEnabled(true);
            
      mPreguntes = new preguntes(this);
      //Si l'arrayList filtres existeix, el recuperem, sin en creem un de nou
      final ArrayList<filtre> tFiltres = (ArrayList<filtre>) getLastNonConfigurationInstance();
	    if (tFiltres == null) {
	    	filtres = new ArrayList<filtre>();
	    } else filtres = tFiltres;
      
           
      lvFiltres = (ListView)findViewById(R.id.cerca_escrita_llista_filtres);
     // ArrayList<filtre> filtres = new ArrayList<filtre>();
      mFiltresAdapter = new FiltresAdapter(this,R.layout.row_filtre_cercador, filtres);
      lvFiltres.setAdapter(mFiltresAdapter) ;
      
      lvLlistat = (ListView)findViewById(R.id.cerca_escrita_llista);
      textCerca = (EditText)findViewById(R.id.cerca_escrita_text_cerca);
      textCerca.addTextChangedListener(new TextWatcher(){
    	  public void afterTextChanged(Editable s) {
           	  if (s.length()>0)
        		  cercaPerNom(s.toString());
           	  else
           		llistaTots();
    	  }
          public void beforeTextChanged(CharSequence s, int start, int count, int after){}
          public void onTextChanged(CharSequence s, int start, int before, int count){}
      }); 
      llistaTots();
      lvLlistat.requestFocus();
	  // Listener per als ocells selleccionats
	  lvLlistat.setOnItemClickListener(new OnItemClickListener() {
          @Override
          public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
           	  Intent fitxaIntent = new Intent(getApplicationContext(), FitxaOcellActivity.class);
              fitxaIntent.putExtra("id", id);
              startActivity(fitxaIntent);
          }
      });
	  // Listener per borrar filtres
	  lvFiltres.setOnItemClickListener(new OnItemClickListener() {
          @Override
          public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
          	  mFiltresAdapter.remove( mFiltresAdapter.getItem(position));
        	  mFiltresAdapter.notifyDataSetChanged();
        	  actualitzarCercaFiltres();
          }
      });
      
  }
  @Override
	public Object onRetainNonConfigurationInstance() {
	    //Desem l'objecte per a no tronar-lo a carregar quan es destrueix
	    return filtres;
  }

  @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_cerca_escrita, menu);
		return true;
  }
  
  @Override
  public boolean onOptionsItemSelected(MenuItem item) {
      switch (item.getItemId()) {
      		case android.R.id.home:
      			finish();
      			return true;
	        case R.id.cerca_escrita_menu_llistar_tots:
	        	 mFiltresAdapter.clear();
	        	 actualitzarCercaFiltres();
	             textCerca.setText("");
	             lvLlistat.requestFocus();
	             InputMethodManager inputManager = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE); 
	             inputManager.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);
	    		return true;
	        case R.id.cerca_escrita_menu_afegir_filtre:
	        	final Intent filtreIntent2 = new Intent(getApplicationContext(),	FiltresActivity.class);  
	    		startActivityForResult(filtreIntent2, ACTIVITAT_FILTRES_REQUEST_CODE);
                return true;
	        case R.id.cerca_escrita_menu_ordenar:
        		crearDialegCanviOrdre();
        		return true;
	        case R.id.cerca_escrita_menu_preferencies:
           	 	Intent intent2 = new Intent(getApplicationContext(), SettingsActivity.class);
                startActivity(intent2);            	
                return true;
	        case R.id.cerca_escrita_menu_ajuda:
	        	Intent i = new Intent(Intent.ACTION_VIEW);
	           	i.setData(Uri.parse(this.getResources().getString((R.string.url_ajuda))));
	           	startActivity(i);           	
	           	return true;
	        default:
              return false;
      }
	}
  
  protected void onActivityResult(int request_code, int result_code, Intent data) {
		super.onActivityResult(request_code, result_code, data);
		if (request_code == ACTIVITAT_FILTRES_REQUEST_CODE ) {
		     if(result_code == RESULT_OK){
		    	 if (data.getExtras().containsKey("pregunta")){
		    		 String pregunta = data.getStringExtra("pregunta");
		    		 String codi_opcio = data.getStringExtra("codi_opcio");
		    		 boolean trobat = false; 
		    		 for (int i=0; i < mFiltresAdapter.getCount(); i++){
		    			 if (mFiltresAdapter.getItem(i).pregunta.equals(pregunta)){
		    				 mFiltresAdapter.getItem(i).codiOpcio = codi_opcio;
		    				 trobat = true;
		    			 }
		    	 	 }
		    		 if (!trobat)
		    			 mFiltresAdapter.add( new filtre(pregunta,codi_opcio) );
		    		 mFiltresAdapter.notifyDataSetChanged();
		    		 actualitzarCercaFiltres();
		    	 }
		     } else if (result_code == RESULT_CANCELED) {
		 			//Write your code on no result return 
		     }
		}

		super.onActivityResult(request_code, result_code, data);
	}
  
  private void actualitzarCercaFiltres(){
	  Integer preguntaActual;
	  String codiOpcio;
	  View layoutCerca = (View)findViewById(R.id.cerca_escrita_layout_cerca);
	  if (mFiltresAdapter.getCount()==0){
		  //No hi ha cap filtre
		  //TODO deshabilitar i habilitar ordre
		  layoutCerca.setVisibility(View.VISIBLE);
		  llistaTots();
	  }
	  else{
		  //Hi han filtres
		  layoutCerca.setVisibility(View.GONE);
		  textCerca.setText("");
		  //TODO fer algo d'espera!!!!!!
		  mPreguntes.reiniciarPunts();
		  //mPreguntes.TotalPuntsSumats = 0; //TODO per el nou sistema de calcul d'horitzo
		  for (int i=0; i < mFiltresAdapter.getCount(); i++){
			  codiOpcio = mFiltresAdapter.getItem(i).codiOpcio;
			  preguntaActual = mPreguntes.getIdPregunta(mFiltresAdapter.getItem(i).pregunta);
	          codiOpcio = mPreguntes.actualitzaPreguntes(preguntaActual, codiOpcio);
	          if (mFiltresAdapter.getItem(i).pregunta.equals("fenologia"))
	        	  mPreguntes.aplicarFenologia();
	          else
	        	  mPreguntes.actualitzaProbabilitats(preguntaActual, codiOpcio);
	    	  
		  }
		 
		  Integer horitzoSuperior = mPreguntes.cercarHoritzo(defs.PERCENT_HORITZO_SUPERIOR);
		  dbDadesOcellAdapter mdbDadesOcellAdapter = new dbDadesOcellAdapter(this);
		  
		  mdbDadesOcellAdapter.open();
		  Integer especiesHoritzoSuperior = mdbDadesOcellAdapter.getNombreEspeciesHoritzo(horitzoSuperior);
   		  Cursor cursor = mdbDadesOcellAdapter.getEstatCerca(especiesHoritzoSuperior);
   		  mLlistaAdapter = new LlistaAdapter(this, cursor);
		  lvLlistat.setAdapter(mLlistaAdapter);
		  mdbDadesOcellAdapter.close();
		     
	  	  String countString = getResources().getQuantityString(R.plurals.cerca_escrita_resultat_filtres,
	  			especiesHoritzoSuperior, new Object[] {especiesHoritzoSuperior});
	  	 if (android.os.Build.VERSION.SDK_INT >= 11){
	  		 ActionBar ab = getActionBar();
	  		 ab.setSubtitle(countString) ;
	  	 }
	  }
  }
  
  private void llistaTots() {
	   SharedPreferences prefs = getPreferences(MODE_PRIVATE); 
	   int ordre = prefs.getInt(PREFERENCIA_CERCA_ESCRITA_ORDRE, -1); 
	   mdbOcellsAdapter = new dbOcellsAdapter(this);
  	   mdbOcellsAdapter.open();
       Cursor cursor = mdbOcellsAdapter.llistaTots(ordre);
       
       mLlistaAdapter = new LlistaAdapter(this, cursor);
       lvLlistat.setAdapter(mLlistaAdapter);
       int n = cursor.getCount();
       mdbOcellsAdapter.close();   
  	   String countString = getResources().getQuantityString(R.plurals.cerca_escrita_llistar_tot,
                                n, new Object[] {n});
  	   if (android.os.Build.VERSION.SDK_INT >= 11){
  		   ActionBar ab = getActionBar();
  		   ab.setSubtitle(countString) ;
  	   }
  }
  
  private void cercaPerNom(String query) {
 	   mdbOcellsAdapter = new dbOcellsAdapter(this);
  	   mdbOcellsAdapter.open();
  	  
       Cursor cursor = mdbOcellsAdapter.cercaPerNoms(eines.normalitza(query));
       
       mLlistaAdapter = new LlistaAdapter(this, cursor);
       lvLlistat.setAdapter(mLlistaAdapter);
       
       int n = cursor.getCount();
       mdbOcellsAdapter.close();   
  	   String countString = getResources().getQuantityString(R.plurals.cerca_escrita_resultat_cerca,
                                n, new Object[] {n, query});
       
  	   if (android.os.Build.VERSION.SDK_INT >= 11){
  		   ActionBar ab = getActionBar();
  		   ab.setSubtitle(countString) ;
  	   }
  	}
	

  	private void crearDialegCanviOrdre(){
		SharedPreferences prefs = getPreferences(MODE_PRIVATE); 
		int ordre = prefs.getInt(PREFERENCIA_CERCA_ESCRITA_ORDRE, -1);
		final String[] items = {
				 getResources().getString(R.string.cerca_escrita_dialeg_canvi_ordre_nom_catala),
				 getResources().getString(R.string.cerca_escrita_dialeg_canvi_ordre_nom_cientific),
				 getResources().getString(R.string.cerca_escrita_dialeg_canvi_ordre_familia),
				 getResources().getString(R.string.cerca_escrita_dialeg_canvi_ordre_tamany)};
		AlertDialog.Builder dialog = new AlertDialog.Builder(this);
		dialog.setTitle(R.string.cerca_escrita_dialeg_canvi_ordre_titol);
		dialog.setSingleChoiceItems(items, ordre, new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int item) { 
				SharedPreferences.Editor prefs = getPreferences(MODE_PRIVATE).edit();
				prefs.putInt(PREFERENCIA_CERCA_ESCRITA_ORDRE, item);
				prefs.commit();
				dialog.dismiss();
				llistaTots();
			 }
		});
		dialog.show();
	}
	
	
	public class LlistaAdapter extends CursorAdapter {
		 
		private final Activity context;
	    private Cursor c;
	    private LayoutInflater mInflater=null;
	         
	 
	    public LlistaAdapter(Context context, Cursor c) {
	    	super(context, c);
	    	this.context = (Activity) context;
	        this.c = c;
	        c.moveToFirst();
	        mInflater = LayoutInflater.from(context);
	    }
	    
	    
	    @Override
	    public void bindView(View view, Context context, final Cursor cursor) {
	    }
	    
	    @Override
	    public View newView(Context context, Cursor cursor, ViewGroup parent) {
	        return mInflater.inflate(R.layout.row_ocell_cercador, null);
	    }
	    
	    public View getView(int position, View convertView, ViewGroup parent) {
	    	if (convertView == null) {
	    	      mInflater = context.getLayoutInflater();
	    	      convertView = mInflater.inflate(R.layout.row_ocell_cercador, null);
	    	}   
	    	c.moveToPosition(position);
	        TextView nomCatala = (TextView)convertView.findViewById(R.id.row_ocell_cercador_nom_catala);
	        TextView nomCientific = (TextView)convertView.findViewById(R.id.row_ocell_cercador_nom_cientific);
	        ImageView imatge = (ImageView)convertView.findViewById(R.id.row_ocell_cercador_icona);
	        Button botoAfegir = (Button)convertView.findViewById(R.id.row_ocell_cercador_boto_afegir);
	               
	        String sNomCatala = c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CATALA));
	        if (mFiltresAdapter.getCount()>0){
		        String tipus = c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_MASCLE));
				tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_FEMELLA)).trim();
				tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_ADULT)).trim();
				tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_JOVE)).trim();
				tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_NUPCIAL)).trim();
				tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_RESTA)).trim();
		        if (!tipus.trim().equals(""))
		        	sNomCatala += " (" + tipus.trim() + ")";
	        }
	        nomCatala.setText(sNomCatala);
	        
	        
	        nomCientific.setText(c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CIENTIFIC)));
	        
	        String nom_imatge = c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CIENTIFIC));
	        nom_imatge = eines.nomFitxer(nom_imatge);
	        int id_imatge = context.getResources().getIdentifier(nom_imatge, "drawable", context.getPackageName());
	        
	        if (id_imatge == 0)
	        	imatge.setImageDrawable(context.getResources().getDrawable(R.drawable.icona_ocell));	
	        else
	        	imatge.setImageDrawable(context.getResources().getDrawable(id_imatge));

	        botoAfegir.setTag(c.getInt(0));
	        botoAfegir.setOnClickListener(new OnClickListener() {
	          @Override
	          public void onClick(View v) {
	        	  final int idOcell = (Integer) v.getTag();
	        	  Intent retornIntent = new Intent(getApplicationContext(), LlistaObservacioActivity.class);
	          	  retornIntent.putExtra("id",String.valueOf(idOcell));
	          	  setResult(RESULT_OK,retornIntent);
	              finish();
	          }
	      });
	        
		    return convertView; 
	    }
	    
	}
	
	public class filtre {
		String pregunta;
		String codiOpcio;
		
		public filtre(String pregunta, String codiOpcio) {
			this.pregunta = pregunta;
			this.codiOpcio = codiOpcio;
		}
		
	}
	
	public class FiltresAdapter extends ArrayAdapter<filtre>{

	    Context context; 
	    int layoutResourceId;    
	    ArrayList<filtre> filtres = null;
	    
	    public FiltresAdapter(Context context, int layoutResourceId, ArrayList<filtre> filtres) {
	        super(context, layoutResourceId);
	        this.layoutResourceId = layoutResourceId;
	        this.context = context;
	        this.filtres = filtres;
	    }

	    @Override
	    public View getView(int position, View convertView, ViewGroup parent) {
	        View row = convertView;
	               
	        if(row == null)
	        {
	            LayoutInflater inflater = ((Activity)context).getLayoutInflater();
	            row = inflater.inflate(layoutResourceId, parent, false);
	        }
	        
	        TextView text = (TextView)row.findViewById(R.id.row_filtre_cercador_nom);
	        ImageView icona = (ImageView)row.findViewById(R.id.row_filtre_cercador_icona);

	        String textFiltre = "";
	        Integer idPregunta = mPreguntes.getIdPregunta(this.getItem(position).pregunta);
	        String nomOpcions = mPreguntes.p.get(idPregunta).opcions;
            //Si es la pregunta de fenologia, retornem les opcions per mostrar, no les de clcul
	        if (this.getItem(position).pregunta.equals("fenologia"))
	        	nomOpcions = "opcionsFenologiaMostrarFiltres";
            //Si es la pregunta de fenologia, retornem les opcions per mostrar, no les de clcul
	        if (this.getItem(position).pregunta.equals("habitat"))
	        	nomOpcions = "opcionsHabitatPerMostrar";
	    	Integer idOpcions = mPreguntes.getIdOpcionsPregunta(nomOpcions);
	    	Integer idOpcio = mPreguntes.o.get(idOpcions).getIdOpcio(this.getItem(position).codiOpcio);
	    	
	    	textFiltre = mPreguntes.p.get(idPregunta).text2;
	    	textFiltre += ": ";
	    	textFiltre += mPreguntes.o.get(idOpcions).text[idOpcio];
	        
	    	//Si es la pregunta de fenologia, afegim el mes de l'any en el qual s'aplica
	        if (this.getItem(position).pregunta.equals("fenologia")){
	        	SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
	    		String dataFenologia = pref.getString("preferencies_data_fenologia", "-1");
	    		String stringRecursMes;
	    		if (dataFenologia.equals("-1"))
	    			stringRecursMes = "mes_" + eines.getMesNumeric();
	    		else
	    			stringRecursMes = "mes_" + dataFenologia;
	        	Integer idRecursMes = getResources().getIdentifier(stringRecursMes, "string", context.getPackageName());
	        	textFiltre = mPreguntes.o.get(idOpcions).text[idOpcio] + ": " + getResources().getString(idRecursMes);
	        }
	    	
	    	text.setText(textFiltre);
	        
	    	String recurs = mPreguntes.o.get(idOpcions).recurs[idOpcio];
	        Integer idImatge = context.getResources().getIdentifier(recurs, "drawable", context.getPackageName());
	        if (idImatge != 0)
	        	   icona.setImageResource(idImatge);
        
	        return row;
	    }
	}
}