package catalunya.de.ocells;

import java.util.ArrayList;
import java.util.List;

import catalunya.de.ocells.db.dbOcellsAdapter;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.database.Cursor;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.widget.Toast;

public class CercaReconeixementVeuActivity extends Activity {
	
	private dbOcellsAdapter mdbOcellsAdapter;
    private static final int VOICE_RECOGNITION_REQUEST_CODE = 1234;
   // private Handler mHandler;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
  
        // Check to see if a recognition activity is present
        PackageManager pm = getPackageManager();
        List<ResolveInfo> activities = pm.queryIntentActivities(
                new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH), 0);
        if (activities.size() != 0) {
        	startVoiceRecognitionActivity();
        } else {
           //no hi ha reconeixement de veu
        }
    }
 
    private void startVoiceRecognitionActivity() {
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);

        // Specify the calling package to identify your application
        intent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, getClass().getPackage().getName());

        // Display an hint to the user about what he should say.
        intent.putExtra(RecognizerIntent.EXTRA_PROMPT, R.string.cerca_reconeixement_veu_missatge_inici_dictat);

        // Given an hint to the recognizer about what the user is going to say
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,
                RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);

        // Specify how many results you want to receive. The results will be sorted
        // where the first result is the one with higher confidence.
        intent.putExtra(RecognizerIntent.EXTRA_MAX_RESULTS, 5);

        // Specify the recognition language. This parameter has to be specified only if the
        // recognition has to be done in a specific language and not the default one (i.e., the
        // system locale). Most of the applications do not have to set this parameter.
        
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE,"ca-ES");
        
        startActivityForResult(intent, VOICE_RECOGNITION_REQUEST_CODE);
    }

    /**
     * Handle the results from the recognition activity.
     */
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == VOICE_RECOGNITION_REQUEST_CODE && resultCode == RESULT_OK) {
            // Fill the list view with the strings the recognizer thought it could have heard
            ArrayList<String> matches = data.getStringArrayListExtra(
                    RecognizerIntent.EXTRA_RESULTS);
            //Toast.makeText(this, "Tenim "+String.valueOf(matches.size()) +" alternatives" , Toast.LENGTH_SHORT).show();
            mdbOcellsAdapter = new dbOcellsAdapter(this);
            mdbOcellsAdapter.open();
            
            int i=0;
            String id="";
            boolean trobat = false;
            while (i < matches.size()){   //Cerquem totes les respostes a la BBDD. Si alguna existeix, acabem.
            	Cursor cursor = mdbOcellsAdapter.cercaPerVeu(matches.get(i));
            	if (cursor.getCount() > 0 ){
            		trobat= true;
            			cursor.moveToFirst();
                        id = cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_ID));
            			//id = cursor.getString(dbAdapter.OCELLS_ROW_ID);
            		break;
            	}
            	i++;
            }
           
            Intent retornIntent = getIntent(); 
            if (trobat){
            	retornIntent.putExtra("id",id);
            	setResult(RESULT_OK,retornIntent); 
            } else{
            	Toast.makeText(this, R.string.cerca_reconeixement_veu_toast_missatge_no_trobat , Toast.LENGTH_SHORT).show();            	
                setResult(RESULT_CANCELED, retornIntent);        
            }
        }
        finish();
        super.onActivityResult(requestCode, resultCode, data);
    }

}
