package catalunya.de.ocells;

import java.util.ArrayList;

import android.app.ExpandableListActivity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.BaseExpandableListAdapter;
import android.widget.ExpandableListAdapter;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import catalunya.de.ocells.cerca.pregunta;
import catalunya.de.ocells.cerca.preguntes;

public class FiltresActivity extends ExpandableListActivity {

   ExpandableListAdapter mAdapter;
   preguntes mPreguntes;
   public ArrayList<String> llistaPreguntes;
   Context context;

   @Override
   public void onCreate(Bundle savedInstanceState) {
       super.onCreate(savedInstanceState);
       if (android.os.Build.VERSION.SDK_INT >= 11)
    	   getActionBar().setDisplayHomeAsUpEnabled(true);
	   	final preguntes tPreguntes = (preguntes) getLastNonConfigurationInstance();
	    if (tPreguntes == null) {
	    	mPreguntes = new preguntes(this);
	    } else mPreguntes = tPreguntes;
       // Set up our adapter
	   carregaLlista();
	   context = this;
       mAdapter = new MyExpandableListAdapter();
       setListAdapter(mAdapter);
       getExpandableListView().setOnChildClickListener(this);
       
   }
   
   @Override
   public boolean onChildClick(ExpandableListView parent, View v, int groupPosition,
           int childPosition, long id) {
	    Integer idPregunta = mPreguntes.getIdPregunta(llistaPreguntes.get(groupPosition));
 	    String nomOpcions = mPreguntes.p.get(idPregunta).opcions;
 	    Integer idOpcions = mPreguntes.getIdOpcionsPregunta(nomOpcions);
 	    String codiOpcio = mPreguntes.o.get(idOpcions).codiOpcio[childPosition];
 	    
 	    Intent retornIntent = new Intent(getApplicationContext(), LlistaObservacioActivity.class);
 	    retornIntent.putExtra("pregunta", llistaPreguntes.get(groupPosition));
   	    retornIntent.putExtra("codi_opcio", codiOpcio);
   	    //Toast.makeText(this, llistaPreguntes.get(groupPosition) + "," + codiOpcio , Toast.LENGTH_SHORT).show();
   	    setResult(RESULT_OK,retornIntent);
       finish();
       return true;
   }
   
   
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_filtres, menu);
		return true;
	}
	
	@Override
   public boolean onOptionsItemSelected(MenuItem item) {
       switch (item.getItemId()) {
       	   case android.R.id.home:
       		   finish();
       		   return true;
           case R.id.filtres_menu_preferencies:
           	   Intent intent = new Intent(getApplicationContext(), SettingsActivity.class);
               startActivity(intent);            	
           	   return true;
           case R.id.filtres_menu_ajuda:
        	   Intent i = new Intent(Intent.ACTION_VIEW);
           	   i.setData(Uri.parse(this.getResources().getString((R.string.url_ajuda))));
           	   startActivity(i);           	
           	   return true;
           default:
               return false;
       }
	}
   
   @Override
	public Object onRetainNonConfigurationInstance() {
	    //Desem l'objecte per a no tronar-lo a carregar quan es destrueix
	    return mPreguntes;
	}

   public void carregaLlista(){
	   Integer i;
	   //desactivem pregunta de caracteristica unica i activem color secudari del bec.
	   //Tamb canviem les opcions de la fenologia per mostrar el boto d'aplicar, ja que a la cerca guiada no hi es
	   mPreguntes.p.get(mPreguntes.getIdPregunta("caracteristicaUnica")).bActiva = false;
	   mPreguntes.p.get(mPreguntes.getIdPregunta("teCresta")).bActiva = false;
	   mPreguntes.p.get(mPreguntes.getIdPregunta("colorCresta")).bActiva = true;
	   mPreguntes.p.get(mPreguntes.getIdPregunta("teLiniaAla")).bActiva = false;
	   mPreguntes.p.get(mPreguntes.getIdPregunta("colorLiniaAla")).bActiva = true;
	   mPreguntes.p.get(mPreguntes.getIdPregunta("becColorPunta")).bActiva = true;
	   mPreguntes.p.get(mPreguntes.getIdPregunta("fenologia")).opcions = "opcionsFenologiaMostrarFiltres";
	   llistaPreguntes = new ArrayList<String>();
	   for (i=0; i < mPreguntes.p.size();i++){
		   pregunta Pregunta = mPreguntes.p.get(i);
		   if (Pregunta.bActiva){// TODO ho tret!!!! && !Pregunta.bFeta){
			   llistaPreguntes.add(Pregunta.nom);}
	   }
	   
   }
   
   public class MyExpandableListAdapter extends BaseExpandableListAdapter {
       public Object getChild(int groupPosition, int childPosition) {
    	   Integer idPregunta = mPreguntes.getIdPregunta(llistaPreguntes.get(groupPosition));
    	   String nomOpcions = mPreguntes.p.get(idPregunta).opcions;
    	   Integer idOpcio = mPreguntes.getIdOpcionsPregunta(nomOpcions);
    	   return mPreguntes.o.get(idOpcio).text[childPosition];
       }

       public long getChildId(int groupPosition, int childPosition) {
           return childPosition;
       }

       public int getChildrenCount(int groupPosition) {
    	   Integer idPregunta = mPreguntes.getIdPregunta(llistaPreguntes.get(groupPosition));
    	   String nomOpcions = mPreguntes.p.get(idPregunta).opcions;
    	   Integer idOpcio = mPreguntes.getIdOpcionsPregunta(nomOpcions);
    	   return mPreguntes.o.get(idOpcio).recurs.length;
       }

       public View getChildView(int groupPosition, int childPosition, boolean isLastChild,
               View convertView, ViewGroup parent) {
              	   
    	   View v = convertView;
           if (v == null) {
        	   LayoutInflater inflater;
        	   inflater = LayoutInflater.from(context);
        	   v = inflater.inflate(R.layout.row_filtre_opcio, null);
        	   //sender is activity from where you call this adapter. Set it with construktor.
           }
 
           Integer idPregunta = mPreguntes.getIdPregunta(llistaPreguntes.get(groupPosition));
    	   String nomOpcions = mPreguntes.p.get(idPregunta).opcions;
    	   Integer idOpcions = mPreguntes.getIdOpcionsPregunta(nomOpcions);
           
           TextView nom = (TextView) v.findViewById(R.id.row_filtre_opcio_nom);
           ImageView icona = (ImageView) v.findViewById(R.id.row_filtre_opcio_icona);
           
           nom.setText(mPreguntes.o.get(idOpcions).text[childPosition].toString());
           String recurs = mPreguntes.o.get(idOpcions).recurs[childPosition];
           Integer idImatge = context.getResources().getIdentifier(recurs, "drawable", context.getPackageName());
           if (idImatge != 0)
        	   icona.setImageResource(idImatge);
           
           return v;
    	   
       }

       public Object getGroup(int groupPosition) {
           return mPreguntes.p.get(groupPosition);
       }

       public int getGroupCount() {
           return llistaPreguntes.size();
       }

       public long getGroupId(int groupPosition) {
           return groupPosition;
       }

       public View getGroupView(int groupPosition, boolean isExpanded, View convertView,
               ViewGroup parent) {
    	   View v = convertView;
           if (v == null) {
        	   LayoutInflater inflater;
        	   inflater = LayoutInflater.from(context);
        	   v = inflater.inflate(R.layout.row_filtre_pregunta, null);
        	   
           }
    	   Integer idPregunta = mPreguntes.getIdPregunta(llistaPreguntes.get(groupPosition));
           TextView nom = (TextView) v.findViewById(R.id.row_filtre_pregunta_nom);
           ImageView icona = (ImageView) v.findViewById(R.id.row_filtre_pregunta_icona);
           
           nom.setText(mPreguntes.p.get(idPregunta).text2.toString());
           String recurs = mPreguntes.p.get(idPregunta).imatge2;
           if (recurs!=null){
        	   Integer idImatge = context.getResources().getIdentifier(recurs, "drawable", context.getPackageName());
        	   if (idImatge != 0)
        		   icona.setImageResource(idImatge);
           }
           return v;
       }

       public boolean isChildSelectable(int groupPosition, int childPosition) {
           return true;
       }

       public boolean hasStableIds() {
           return true;
       }
   }
}
