package catalunya.de.ocells;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import catalunya.de.ocells.db.dbDadesOcellAdapter;
import catalunya.de.ocells.db.dbOcellsAdapter;

public class FitxaOcellActivity extends Activity {

	private dbOcellsAdapter mdbOcellsAdapter;
	private dbDadesOcellAdapter mdbDadesOcellAdapter;
	private static String urlIco = "http://www.sioc.cat/fitxa.php?sci=0&sp=";
	private static String urlWikipedia = "http://ca.wikipedia.org/wiki/";
	private String urlMesInfoIco, urlMesInfoWiki;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_fitxa_ocell);
		
		if (android.os.Build.VERSION.SDK_INT >= 11)
			getActionBar().setDisplayHomeAsUpEnabled(true);
		TextView tvNomCatala = (TextView) findViewById(R.id.fitxa_ocell_nom_catala);
		TextView tvNomAltres = (TextView) findViewById(R.id.fitxa_ocell_nom_altres);
		TextView tvNomCientific = (TextView) findViewById(R.id.fitxa_ocell_nom_cientific);
		TextView tvFamilia = (TextView) findViewById(R.id.fitxa_ocell_familia);
		ImageView imgImatge = (ImageView) findViewById(R.id.fitxa_ocell_imatge);
		TextView tvTamany = (TextView) findViewById(R.id.fitxa_ocell_tamany);
		TextView tvEstatus = (TextView) findViewById(R.id.fitxa_ocell_estatus);
		TextView tvFenologia1 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_1);
		TextView tvFenologia2 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_2);
		TextView tvFenologia3 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_3);
		TextView tvFenologia4 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_4);
		TextView tvFenologia5 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_5);
		TextView tvFenologia6 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_6);
		TextView tvFenologia7 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_7);
		TextView tvFenologia8 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_8);
		TextView tvFenologia9 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_9);
		TextView tvFenologia10 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_10);
		TextView tvFenologia11 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_11);
		TextView tvFenologia12 = (TextView) findViewById(R.id.fitxa_ocell_fenologia_12);
		Button bMesInfoIco = (Button)findViewById(R.id.fitxa_ocell_boto_mes_info_ico);
		Button bMesInfoWiki = (Button)findViewById(R.id.fitxa_ocell_boto_mes_info_wiki);
		bMesInfoIco.setOnClickListener(botoMesInfoIcoListener);
		bMesInfoWiki.setOnClickListener(botoMesInfoWikiListener);
		long id = getIntent().getLongExtra("id", 0) ;
				
		mdbOcellsAdapter = new dbOcellsAdapter(this);
	    mdbOcellsAdapter.open();
	    Cursor cursor = mdbOcellsAdapter.dadesOcell(id);
	    
	    
	    if (cursor == null) {
            finish();
        } else {
            cursor.moveToFirst();
            tvNomCatala.setText(cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_NOM_CATALA)));
            tvNomAltres.setText(cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_NOM_ALTRES)).trim());
            if (tvNomAltres.getText().equals(""))
            	tvNomAltres.setVisibility(View.GONE);
            tvNomCientific.setText(cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_NOM_CIENTIFIC)));
            tvFamilia.setText(cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_FAMILIA)));
            
            String nom_imatge = cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_NOM_CIENTIFIC));
            nom_imatge = nom_imatge.replace(" ", "_").toLowerCase();
            int id_imatge = this.getResources().getIdentifier(nom_imatge, "drawable", this.getPackageName());
    	    if (id_imatge != 0)
    	    	imgImatge.setImageDrawable(this.getResources().getDrawable(id_imatge));
    	    else
    	    	imgImatge.setVisibility(View.GONE);
    	    
    	    tvTamany.setText(cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_TAMANY_MIN)) + " - " + 
    	    		cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_TAMANY_MAX) ) + "cm.");
            
    	    String estatus = cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_ESTATUS));
    	    String rar = cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_RAR));
    	    String cadenaEstatus = "";
    	    Integer colorFenologia1 = 0, colorFenologia2 = 0;
    	    if (estatus.trim().equals("r")){
            	cadenaEstatus += getResources().getString(R.string.fitxa_ocell_resident);
            	colorFenologia1 = R.color.fenologia_resident_1;
            	colorFenologia2 = R.color.fenologia_resident_2;
	        }
	        if (estatus.trim().equals("e")){
            	cadenaEstatus += getResources().getString(R.string.fitxa_ocell_estival);
            	colorFenologia1 = R.color.fenologia_estival_1;
            	colorFenologia2 = R.color.fenologia_estival_2;
	        }
	        if (estatus.trim().equals("h")){
	        	cadenaEstatus += getResources().getString(R.string.fitxa_ocell_hivernant);
	        	colorFenologia1 = R.color.fenologia_hivernant_1;
            	colorFenologia2 = R.color.fenologia_hivernant_2;
	        }
	        if (estatus.trim().equals("p")){
            	cadenaEstatus += getResources().getString(R.string.fitxa_ocell_de_pas);
            	colorFenologia1 = R.color.fenologia_de_pas_1;
            	colorFenologia2 = R.color.fenologia_de_pas_2;
	        }
	        if (rar.trim().equals("r"))
            	cadenaEstatus += getResources().getString(R.string.fitxa_ocell_rar);
            else if (rar.trim().equals("a"))
            	cadenaEstatus += getResources().getString(R.string.fitxa_ocell_accidental);
	        tvEstatus.setText(cadenaEstatus);
	        
            mdbDadesOcellAdapter = new dbDadesOcellAdapter(this);
    	    mdbDadesOcellAdapter.open();
    	    Cursor cursor2 = mdbDadesOcellAdapter.getDadesOcell(id);
    	    
    	    if (cursor2 != null && cursor2.getCount()!=0) {
    	    	cursor2.moveToFirst();
    	        String fenologia;
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_1)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia1.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia1.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia1.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia1.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_2)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia2.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia2.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia2.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia2.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_3)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia3.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia3.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia3.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia3.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_4)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia4.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia4.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia4.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia4.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_5)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia5.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia5.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia5.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia5.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_6)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia6.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia6.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia6.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia6.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_7)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia7.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia7.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia7.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia7.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_8)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia8.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia8.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia8.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia8.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_9)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia9.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia9.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia9.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia9.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_10)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia10.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia10.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia10.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia10.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_11)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia11.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia11.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia11.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia11.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	        fenologia = cursor2.getString(cursor2.getColumnIndex(dbDadesOcellAdapter.KEY_FENOLOGIA_12)).trim();
    	        if (fenologia.equals("1")){
    	        	tvFenologia12.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia12.setBackgroundColor(getResources().getColor(colorFenologia1));
    	        } else if (fenologia.equals("2")){
    	        	tvFenologia12.setTextColor(getResources().getColor(R.color.text_blanc));
    	        	tvFenologia12.setBackgroundColor(getResources().getColor(colorFenologia2));
    	        }
    	       
    	    }
    	    else{
        	}
    	    
    	    String codiIco = cursor.getString(cursor.getColumnIndex(dbOcellsAdapter.KEY_CODI_ICO)).trim();
    	    urlMesInfoIco = urlIco + codiIco;
        	urlMesInfoWiki = urlWikipedia + tvNomCientific.getText();
    	    
    	    if (codiIco.length()==0){
    	    	bMesInfoIco.setVisibility(View.GONE);
    	    }
    	    cursor2.close();
    	    mdbDadesOcellAdapter.close();
        }
	    cursor.close();
	    mdbOcellsAdapter.close();

   	 
	}

	private OnClickListener botoMesInfoIcoListener = new OnClickListener() {
        public void onClick(View v) {
        	Intent i = new Intent(Intent.ACTION_VIEW);
        	i.setData(Uri.parse(urlMesInfoIco));
        	startActivity(i);
        }
	};
	private OnClickListener botoMesInfoWikiListener = new OnClickListener() {
        public void onClick(View v) {
        	Intent i = new Intent(Intent.ACTION_VIEW);
        	i.setData(Uri.parse(urlMesInfoWiki));
        	startActivity(i);
        }
	};
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_fitxa_ocell, menu);
		return true;
	}
	
	
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        	case android.R.id.home:
        		finish();
        		return true;
        	case R.id.fitxa_ocell_menu_preferencies:
           	 	Intent intent = new Intent(getApplicationContext(), SettingsActivity.class);
                startActivity(intent);            	
                return true;
        	case R.id.fitxa_ocell_menu_ajuda:
 	        	Intent i = new Intent(Intent.ACTION_VIEW);
 	           	i.setData(Uri.parse(this.getResources().getString((R.string.url_ajuda))));
 	           	startActivity(i);           	
 	           	return true;
            default:
                return false;
        }
	}	

}


