package catalunya.de.ocells;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.media.AudioManager;
import android.media.ToneGenerator;
import android.text.InputType;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CursorAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import catalunya.de.ocells.db.dbOcellsAdapter;
import catalunya.de.ocells.db.dbOcellsLlistaAdapter;

public class LlistaObservacioAdapter extends CursorAdapter {
	 
	private final Activity context;
    private Cursor c;
    private static LayoutInflater mInflater=null;
    private long idLlista;
    private static long idOcellDialegs;
     
 
    public LlistaObservacioAdapter(Context context, Cursor c, long idLlista) {
    	super(context, c);
    	this.context = (Activity) context;
        this.c = c;
        this.idLlista = idLlista;
        c.moveToFirst();
        mInflater = LayoutInflater.from(context);
    }
    
    
    @Override
    public void bindView(View view, Context context, final Cursor cursor) {
    }
    
    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        return mInflater.inflate(R.layout.row_ocell_llista_observacio, null);
    }
    
    public View getView(int position, View convertView, ViewGroup parent) {
    	if (convertView == null) {
    	      mInflater = context.getLayoutInflater();
    	      convertView = mInflater.inflate(R.layout.row_ocell_llista_observacio, null);
    	}   
    	c.moveToPosition(position);
        TextView nomCatala = (TextView)convertView.findViewById(R.id.row_ocell_llista_observacio_nom_catala);
        TextView nomCientific = (TextView)convertView.findViewById(R.id.row_ocell_llista_observacio_nom_cientific);
        Button nombre = (Button)convertView.findViewById(R.id.row_ocell_llista_observacio_nombre);
        TextView anotacio = (TextView)convertView.findViewById(R.id.row_ocell_llista_observacio_anotacio);
        ImageView imatge = (ImageView)convertView.findViewById(R.id.row_ocell_llista_observacio_icona);
   
        nomCatala.setText(c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CATALA)));
        nomCientific.setText(c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CIENTIFIC)));
        nombre.setText(c.getString(c.getColumnIndex(dbOcellsLlistaAdapter.KEY_QUANTITAT)));
        
        //nombre.setCompoundDrawablesRelative(start, top, end, bottom)
        //Afegim TAG a nombre per poder identificar el textView clicat
        nombre.setTag(c.getInt(0));
        //Amaguem anotaci si no hi ha res
        anotacio.setText(c.getString(c.getColumnIndex(dbOcellsLlistaAdapter.KEY_ANOTACIO)));
        String strAnotacio = c.getString(c.getColumnIndex(dbOcellsLlistaAdapter.KEY_ANOTACIO));
        if (strAnotacio!=null && strAnotacio.trim().length()!=0)
         	anotacio.setVisibility(View.VISIBLE);
     	else
        	anotacio.setVisibility(View.GONE);
        
        String nom_imatge = c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CIENTIFIC));
        nom_imatge = eines.nomFitxer(nom_imatge);
        int id_imatge = context.getResources().getIdentifier(nom_imatge, "drawable", context.getPackageName());
        
        if (id_imatge == 0)
        	imatge.setImageDrawable(context.getResources().getDrawable(R.drawable.icona_ocell));	
        else
        	imatge.setImageDrawable(context.getResources().getDrawable(id_imatge));
	    
        //TODO moure listeners i dialegs a l'activitat?
	    nombre.setOnClickListener(new View.OnClickListener(){
	         @Override
	         public void onClick(View v) {
	        	 //eines.reproduirSo();
	        	 final int idOcell = (Integer) v.getTag();
	        	 dbOcellsLlistaAdapter mdbOcellsLlistaAdapter = new dbOcellsLlistaAdapter(context);
	        	 mdbOcellsLlistaAdapter.open();
	      		 mdbOcellsLlistaAdapter.afegirOcellLlista(idLlista,idOcell,1);
	      		 mdbOcellsLlistaAdapter.close();
	      		 reloadCursor();
	          }
	    }); 
	    
	    nombre.setOnLongClickListener(new View.OnLongClickListener() {
			    @Override
			    public boolean onLongClick(View v) {
			    	idOcellDialegs = (Integer) v.getTag();
			    	TextView tvNombreOcells =  (TextView) v;
			    	crearDialegCanviNombre(Integer.valueOf(tvNombreOcells.getText().toString()));
			    	reloadCursor();
         	    return true;
			    }
 	    });
	     
	    return convertView; 
    }

    
	private void crearDialegCanviNombre(int nombre_inicial)
  {
		
		final Dialog dialog = new Dialog(context);
		dialog.setContentView(R.layout.dialog_canvi_nombre_ocells_llista_observacio);
		dialog.setTitle(R.string.dialeg_canvi_nombre_ocells_llista_observacio_titol);

		final EditText etNombre = (EditText) dialog.findViewById(R.id.dialog_canvi_nombre_ocells_llista_observacio_nombre);
		etNombre.setInputType(InputType.TYPE_CLASS_NUMBER | InputType.TYPE_TEXT_FLAG_IME_MULTI_LINE);
		etNombre.setText(String.valueOf(nombre_inicial));
		
		Button btnDesar = (Button) dialog.findViewById(R.id.dialog_canvi_nombre_ocells_llista_observacio_desar);
		Button btnCancelar = (Button) dialog.findViewById(R.id.dialog_canvi_nombre_ocells_llista_observacio_cancelar);
		Button btnSumaU = (Button) dialog.findViewById(R.id.dialog_canvi_nombre_ocells_llista_observacio_suma_unitat);
		Button btnSumaD = (Button) dialog.findViewById(R.id.dialog_canvi_nombre_ocells_llista_observacio_suma_desena);
		Button btnSumaC = (Button) dialog.findViewById(R.id.dialog_canvi_nombre_ocells_llista_observacio_suma_centenar);
 
		btnDesar.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Integer nombre;
				try{
					nombre = Integer.parseInt(etNombre.getText().toString());
				}
				catch (NumberFormatException e) {
					nombre = 0;
				}
				dbOcellsLlistaAdapter mdbOcellsLlistaAdapter = new dbOcellsLlistaAdapter(context);
			    mdbOcellsLlistaAdapter.open();
			    mdbOcellsLlistaAdapter.setNombreOcellsLlista(idLlista, idOcellDialegs, nombre);
			    mdbOcellsLlistaAdapter.close();
			    reloadCursor();
			    dialog.cancel();
			}
		});
		
		btnCancelar.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
			    dialog.cancel();
			}
		});
		btnSumaU.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Integer nombre;
				try{
					nombre = Integer.parseInt(etNombre.getText().toString());
					nombre++;
					etNombre.setText(String.valueOf(nombre));
				}
				catch (NumberFormatException e) {
					Log.e("Ocells", "error de conversi: " + e.getMessage());
				}
			}
		});
		btnSumaD.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Integer nombre;
				try{
					nombre = Integer.parseInt(etNombre.getText().toString());
					nombre = nombre + 10;
					etNombre.setText(String.valueOf(nombre));
				}
				catch (NumberFormatException e) {
					Log.e("Ocells", "error de conversi: " + e.getMessage());
				}
			}
		});
		btnSumaC.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Integer nombre;
				try{
					nombre = Integer.parseInt(etNombre.getText().toString());
					nombre = nombre + 100;
					etNombre.setText(String.valueOf(nombre));
				}
				catch (NumberFormatException e) {
					Log.e("Ocells", "error de conversi: " + e.getMessage());
				}
			}
		});

		dialog.show();
  }
    
    
    
    public void reloadCursor(){
    	SharedPreferences prefs = context.getPreferences(LlistaObservacioActivity.MODE_PRIVATE); 
		int ordre = prefs.getInt(LlistaObservacioActivity.PREFERENCIA_LLISTA_OBSERVACIO_ORDRE, -1);
    	dbOcellsAdapter mdbOcellsAdapter = new dbOcellsAdapter(context);
		mdbOcellsAdapter.open();
		c = mdbOcellsAdapter.getOcellsLlista(idLlista, ordre);
		notifyDataSetChanged();
		
    }
    
}