package catalunya.de.ocells.cerca;

import java.util.ArrayList;

import android.app.ActionBar;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.view.Display;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.CursorAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;
import catalunya.de.ocells.FitxaOcellActivity;
import catalunya.de.ocells.R;
import catalunya.de.ocells.SettingsActivity;
import catalunya.de.ocells.eines;
import catalunya.de.ocells.db.dbDadesOcellAdapter;
import catalunya.de.ocells.db.dbOcellsAdapter;

/**
 * Activitat per a la consulta de l'estat de la cerca
 * @author jsirera
 *
 */
public class EstatCercaActivity extends Activity {
	
	//private dbDadesOcellAdapter mdbDadesOcellAdapter;
	private LlistaAdapter mLlistaAdapter;
	private ListView lvLlistat;
	
	private Integer horitzoSuperior;
	private Integer horitzoInferior;
	private Integer maxim;
	private Integer minim;
	private Integer ampladaDispositiu;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_estat_cerca);
		dbDadesOcellAdapter mdbDadesOcellAdapter;
		 if (android.os.Build.VERSION.SDK_INT >= 11)
			 getActionBar().setDisplayHomeAsUpEnabled(true);
		lvLlistat = (ListView)findViewById(R.id.estat_cerca_llista);
		mdbDadesOcellAdapter = new dbDadesOcellAdapter(this);
		mdbDadesOcellAdapter.open();
	    Cursor cursor = mdbDadesOcellAdapter.getEstatCerca(null);
	    mLlistaAdapter = new LlistaAdapter(this, cursor);
	    lvLlistat.setAdapter(mLlistaAdapter);
	    
	    horitzoSuperior = cercarHoritzo(defs.PERCENT_HORITZO_SUPERIOR);
	    horitzoInferior = cercarHoritzo(defs.PERCENT_HORITZO_INFERIOR);
	    Integer especies_total = mdbDadesOcellAdapter.getPunts().size();
	    Integer especies_superior = mdbDadesOcellAdapter.getNombreEspeciesHoritzo(horitzoSuperior);
	    Integer especies_inferior = especies_total - mdbDadesOcellAdapter.getNombreEspeciesHoritzo(horitzoInferior);
		    
	    maxim = eines.maxim(mdbDadesOcellAdapter.getPunts());
	    minim = eines.minim(mdbDadesOcellAdapter.getPunts());

	    mdbDadesOcellAdapter.close();
	    Integer alternatives = especies_total - especies_superior - especies_inferior;
	    if (android.os.Build.VERSION.SDK_INT >= 11){
	    	ActionBar ab = getActionBar();
	    	ab.setSubtitle(this.getString(R.string.estat_cerca_millors) + especies_superior + " " + this.getString(R.string.estat_cerca_pitjors) + alternatives + " " + this.getString(R.string.estat_cerca_total) + especies_total) ;
	    }
	    	     
		ampladaDispositiu = eines.getAmpladaDispositiu(getWindowManager());
		
		lvLlistat.setOnItemClickListener(new OnItemClickListener() {
	          @Override
	          public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	        	  Intent fitxaIntent = new Intent(getApplicationContext(), FitxaOcellActivity.class);
	              fitxaIntent.putExtra("id", id);
	              startActivity(fitxaIntent);
	          }
	    });
	}
	
	@Override
		public boolean onCreateOptionsMenu(Menu menu) {
			getMenuInflater().inflate(R.menu.activity_estat_cerca, menu);
			return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
	      switch (item.getItemId()) {
			    case android.R.id.home:
		      		finish();
		      		return true;
			    case R.id.estat_cerca_menu_preferencies:
	           	 	Intent intent2 = new Intent(getApplicationContext(), SettingsActivity.class);
	                startActivity(intent2);            	
	                return true;
			    case R.id.estat_cerca_menu_ajuda:
		        	Intent i = new Intent(Intent.ACTION_VIEW);
		           	i.setData(Uri.parse(this.getResources().getString((R.string.url_ajuda))));
		           	startActivity(i);           	
		           	return true;
		        default:
	              return false;
	      }
	}	

	// Aquesta funcio s una copia de la que hi ha a preguntes.class!!!!
	public Integer cercarHoritzo(Integer tipus_horitzo){
		// TODO modificar aquesta manera de trobar-lo?
		ArrayList<Integer> punts;
		dbDadesOcellAdapter mdbDadesOcellAdapter;
		mdbDadesOcellAdapter = new dbDadesOcellAdapter(this);
		mdbDadesOcellAdapter.open();
		punts = mdbDadesOcellAdapter.getPunts();
		Integer maxim = eines.maxim(punts);
		Integer minim = eines.minim(punts);
		Double horitzo = (double) (maxim - minim ) * tipus_horitzo / 100 ;
		horitzo = horitzo + minim;
		//mdbDadesOcellAdapter.close();
		return horitzo.intValue();
	}
	
	
	
	public class LlistaAdapter extends CursorAdapter {
		 
		private final Activity context;
	    private Cursor c;
	    private LayoutInflater mInflater=null;
	         
	 
	    public LlistaAdapter(Context context, Cursor c) {
	    	super(context, c);
	    	this.context = (Activity) context;
	        this.c = c;
	        c.moveToFirst();
	        mInflater = LayoutInflater.from(context);
	    }
	    
	    
	    @Override
	    public void bindView(View view, Context context, final Cursor cursor) {
	    }
	    
	    @Override
	    public View newView(Context context, Cursor cursor, ViewGroup parent) {
	        return mInflater.inflate(R.layout.row_ocell_cercador, null);
	    }
	    
	    public View getView(int position, View convertView, ViewGroup parent) {
	    	if (convertView == null) {
	    	      mInflater = context.getLayoutInflater();
	    	      convertView = mInflater.inflate(R.layout.row_estat_cerca, null);
	    	}   
	    	c.moveToPosition(position);
	    	TextView tvNomCatala = (TextView)convertView.findViewById(R.id.row_estat_cerca_nom_ocell);
	        TextView tvPunts = (TextView)convertView.findViewById(R.id.row_estat_cerca_punts);
	    	
	        Integer punts = c.getInt(c.getColumnIndex(dbDadesOcellAdapter.KEY_PUNTS));
	        Double percent = (double) ((punts - minim) * ampladaDispositiu) / (maxim - minim);
	        tvPunts.setWidth(percent.intValue());
	        tvPunts.setHeight(5);
	        
	        if (punts >= horitzoSuperior)
	        	tvPunts.setBackgroundColor(context.getResources().getColor(R.color.verd_semafor));
	        else if (punts <= horitzoInferior)
	        		tvPunts.setBackgroundColor(context.getResources().getColor(R.color.vermell_semafor));
	        else 
	        	tvPunts.setBackgroundColor( context.getResources().getColor(R.color.taronja_semafor));
	        
	        String sNomCatala = c.getString(c.getColumnIndex(dbOcellsAdapter.KEY_NOM_CATALA));
			String tipus = c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_MASCLE));
			tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_FEMELLA)).trim();
			tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_ADULT)).trim();
			tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_JOVE)).trim();
			tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_NUPCIAL)).trim();
			tipus = tipus.trim() + " " + c.getString(c.getColumnIndex(dbDadesOcellAdapter.KEY_RESTA)).trim();
	        if (!tipus.trim().equals(""))
	        	sNomCatala += " (" + tipus.trim() + ")";
	        sNomCatala += " :" + punts;
	      
	        tvNomCatala.setText(sNomCatala);
	        
		    return convertView; 
	    }
	}
	
}
