package catalunya.de.ocells.cerca;

import java.util.ArrayList;

import catalunya.de.ocells.db.dbDadesOcellAdapter;

/**
 * Definici de les preguntes i opcions per cada pregunta
 * @author jsirera
 *
 */
public final class defs {
	
	public static Integer	PUNTS_INICIALS 				= 0;		//Puntuaci inicial espcies
	public static Integer	PERCENT_HORITZO_SUPERIOR	= 90;		//90 Percentatge de sellecci per a l'horitzo d'especies candidates
	public static Integer	PERCENT_HORITZO_INFERIOR 	= 75;		//75 Percentatge de sellecci per a l'horitzo d'especies amb poca probabilitat
	
	public static String	SENSE_RESPOSTA		= "?";
	public static Integer	MOLT_ALT			= 999999;
	public static Integer	NO					= 999999;
	public static Integer	SENSE_PREGUNTES		= 0; 	// id de la pregunta que indica que s'han acabat les preguntes
	

	public static ArrayList<pregunta> carregaPreguntes(){
    	ArrayList<pregunta> p = new ArrayList<pregunta>();
    	
    	p.add(new pregunta(	
    	/* nom 		*/		"sensePreguntes", /*Esta en primera posici i si s'acaben mostrar aquesta
    	/* activa 	*/		false,
    	/* text 	*/		"Creiem que no calen ms preguntes.",
    	/* text curt*/		null,
    	/* imatge	*/		null,
    	/* imatge2	*/		null,
    	/* key DB	*/		null,
    	/* opcions	*/		null,
    	/* dependen.*/		null,
    	/* ordre min*/		0,
    	/* tipus	*/		pregunta.CONCRETA,
    	/* pes		*/		0
    	));
    	p.add(new pregunta(	
    	/* nom 		*/		"tamanyCodi",
    	/* activa 	*/		true,
    	/* text 	*/		"Quina mida t l'ocell del bec a la cua?",
    	/* text curt*/		"Tamany",
    	/* imatge	*/		"pregunta_tamany",
    	/* imatge2	*/		"pregunta_tamany",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_TAMANY_CODI,
    	/* opcions	*/		"opcionsTamanyCodi",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
    	/* tipus	*/		pregunta.CONCRETA,
    	/* pes		*/		300
    	));
    	p.add(new pregunta(
    	/* nom 		*/		"becLlargada",
    	/* activa 	*/		true,
    	/* text		*/		"Quina llargada t el bec?",
    	/* text curt*/		"Llargada del bec",
    	/* imatge	*/		"pregunta_bec_llargada",
    	/* imatge2	*/		"pregunta_bec_llargada",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_BEC_LLARGADA,
    	/* opcions	*/		"opcionsBecLlargada",
    	/* depend.	*/		null, /* "2, becForma" */
		/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"becForma",
    	/* activa 	*/		true,
    	/* text 	*/		"Quina forma t el bec?",
    	/* text curt*/		"Forma del bec",
    	/* imatge	*/		null,
    	/* imatge2	*/		"pregunta_bec_forma",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_BEC_FORMA,
    	/* opcions	*/		"opcionsBecForma",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"becDoblada",
    	/* activa 	*/		true,
    	/* text 	*/		"Quina doblada t el bec?",
    	/* text curt*/		"Doblada del bec",
    	/* imatge	*/		"pregunta_bec_doblada",
    	/* imatge2	*/		"pregunta_bec_doblada",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_BEC_DOBLADA,
    	/* opcions	*/		"opcionsBecDoblada",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		150
		));
    	p.add(new pregunta(
    	/* nom 		*/		"becColor",
    	/* activa 	*/		true,
    	/* text 	*/		"Quin s el color predominant del bec?",
    	/* text curt*/		"Color predominant bec",
    	/* imatge	*/		"pregunta_bec_color",
    	/* imatge2	*/		"pregunta_bec_color",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_BEC_COLOR,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		", becColorPunta",
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"becColorPunta",
    	/* activa 	*/		false,
    	/* text 	*/		"Quin s el color secundari del bec?",
    	/* text curt*/		"Color secundari bec",
    	/* imatge	*/		"pregunta_bec_color",
    	/* imatge2	*/		"pregunta_bec_color",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_BEC_COLOR_PUNTA,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"potesProporcio",
    	/* activa 	*/		true,
    	/* text 	*/		"Quina s la proporci de les potes respecte al cos?",
    	/* text curt*/		"Proporci potes",
    	/* imatge	*/		"pregunta_potes_proporcio",
    	/* imatge2	*/		"pregunta_potes_proporcio",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_POTES_PROPORCIO,
    	/* opcions	*/		"opcionsPotesProporcio",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"potesColor",
    	/* activa 	*/		true,
    	/* text 	*/		"De quin color son les potes?",
    	/* text curt*/		"Color potes",
    	/* imatge	*/		"pregunta_potes_color",
    	/* imatge	*/		"pregunta_potes_color",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_POTES_COLOR,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"cuaForma",
    	/* activa 	*/		true,
    	/* text 	*/		"Quina llargaria t la cua?",
    	/* text curt*/		"Forma cua",
    	/* imatge	*/		"pregunta_cua_forma",
    	/* imatge2	*/		"pregunta_cua_forma",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_CUA_FORMA,
    	/* opcions	*/		"opcionsCuaForma",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		150
		));
    	p.add(new pregunta(
    	/* nom 		*/		"fenologia",
    	/* activa 	*/		true, 
    	/* text 	*/		null,
    	/* text curt*/		"Fenologia",
    	/* imatge	*/		null,
    	/* imatge2	*/		"pregunta_fenologia",
    	/* key DB	*/		null, //Ho carreguem depenent del mes al mtode aplicarCaracteristiquesImplicites
    	/* opcions	*/		"opcionsFenologia",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.IMPLICITA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"rar",
    	/* activa 	*/		true,
    	/* text 	*/		null,
    	/* text curt*/		"Raresa",
    	/* imatge	*/		null,
    	/* imatge2	*/		"pregunta_rar",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_RAR,
    	/* opcions	*/		"opcionsRaresa",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.IMPLICITA,
		/* pes		*/		150
		));
    	p.add(new pregunta(
    	/* nom 		*/		"aspecteCap",
    	/* activa 	*/		true,
    	/* text 	*/		"Quin aspecte t el cap?",
    	/* text curt*/		"Aspecte cap",
    	/* imatge	*/		"pregunta_aspecte_cap",
    	/* imatge2	*/		"pregunta_aspecte_cap",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_ASPECTE_CAP,
    	/* opcions	*/		"opcionsAspecte",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"aspecteSuperior",
    	/* activa 	*/		true,
    	/* text 	*/		"Quin aspecte t la part superior?",
    	/* text curt*/		"Aspecte superior",
    	/* imatge	*/		"pregunta_aspecte_superior",
    	/* imatge2	*/		"pregunta_aspecte_superior",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_ASPECTE_SUPERIOR,
    	/* opcions	*/		"opcionsAspecte",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"aspecteInferior",
    	/* activa 	*/		true,
    	/* text 	*/		"Quin aspecte t la part inferior?",
    	/* text curt*/		"Aspecte inferior",
    	/* imatge	*/		"pregunta_aspecte_inferior",
    	/* imatge2	*/		"pregunta_aspecte_inferior",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_ASPECTE_INFERIOR,
    	/* opcions	*/		"opcionsAspecte",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"aspecteAla",
    	/* activa 	*/		true,
    	/* text 	*/		"Quin aspecte t l'ala?",
    	/* text curt*/		"Aspecte ala",
    	/* imatge	*/		"pregunta_aspecte_ala",
    	/* imatge2	*/		"pregunta_aspecte_ala",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_ASPECTE_ALA,
    	/* opcions	*/		"opcionsAspecte",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"aspecteCua",
    	/* activa 	*/		true,
    	/* text 	*/		"Quin aspecte t la cua?",
    	/* text curt*/		"Aspecte cua",
    	/* imatge	*/		"pregunta_aspecte_cua",
    	/* imatge2	*/		"pregunta_aspecte_cua",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_ASPECTE_CUA,
    	/* opcions	*/		"opcionsAspecte",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"teLiniaAla",
    	/* activa 	*/		true, 
    	/* text 	*/		"T una lnia a l'ala?",
    	/* text curt*/		"Lnia ala",
    	/* imatge	*/		"pregunta_te_linia_ala",
    	/* imatge2	*/		"pregunta_te_linia_ala",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_TE_LINIA_ALA,
    	/* opcions	*/		"opcionsTeLiniaAla",
    	/* dependen.*/		"s,colorLiniaAla",
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorLiniaAla",
    	/* activa 	*/		false, 
    	/* text 	*/		"De quin color s la lnia de l'ala?",
    	/* text curt*/		"Color lnia ala",
    	/* imatge	*/		"pregunta_color_linia_ala",
    	/* imatge2	*/		"pregunta_color_linia_ala",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_LINIA_ALA,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"teCresta",
    	/* activa 	*/		true, 
    	/* text 	*/		"T cresta?",
    	/* text curt*/		"Cresta",
    	/* imatge	*/		"pregunta_te_cresta",
    	/* imatge2	*/		"pregunta_te_cresta",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_TE_CRESTA,
    	/* opcions	*/		"opcionsTeCresta",
    	/* dependen.*/		"s,colorCresta",
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorCresta",
    	/* activa 	*/		false, 
    	/* text 	*/		"De quin color s la cresta?",
    	/* text curt*/		"Color cresta",
    	/* imatge	*/		"pregunta_color_cresta",
    	/* imatge2	*/		"pregunta_color_cresta",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_CRESTA,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorFront",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t el front?",
    	/* text curt*/		"Color front",
    	/* imatge	*/		"pregunta_color_front",
    	/* imatge2	*/		"pregunta_color_front",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_FRONT,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorPili",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t el pili?",
    	/* text curt*/		"Color pili",
    	/* imatge	*/		"pregunta_color_pili",
    	/* imatge2	*/		"pregunta_color_pili",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_PILI,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorCella",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t la cella?",
    	/* text curt*/		"Color cella",
    	/* imatge	*/		"pregunta_color_cella",
    	/* imatge2	*/		"pregunta_color_cella",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_CELLA,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorAuriculars",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t els auriculars?",
    	/* text curt*/		"Color auriculars",
    	/* imatge	*/		"pregunta_color_auriculars",
    	/* imatge2	*/		"pregunta_color_auriculars",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_AURICULARS,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorClatell",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t el clatell?",
    	/* text curt*/		"Color clatell",
    	/* imatge	*/		"pregunta_color_clatell",
    	/* imatge2	*/		"pregunta_color_clatell",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_CLATELL,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorDors",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t el dors?",
    	/* text curt*/		"Color dors",
    	/* imatge	*/		"pregunta_color_dors",
    	/* imatge2	*/		"pregunta_color_dors",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_DORS,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorCobertoresMitjanes",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les cobertores mitjanes?",
    	/* text curt*/		"Color cobertores mitjanes",
    	/* imatge	*/		"pregunta_color_cobertores_mitjanes",
    	/* imatge2	*/		"pregunta_color_cobertores_mitjanes",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_COBERTORES_MITJANES,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorCobertoresGrans",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les cobertores grans?",
    	/* text curt*/		"Color cobertores grans",
    	/* imatge	*/		"pregunta_color_cobertores_grans",
    	/* imatge2	*/		"pregunta_color_cobertores_grans",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_COBERTORES_GRANS,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorPrimaries",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les primries?",
    	/* text curt*/		"Color primries",
    	/* imatge	*/		"pregunta_color_primaries",
    	/* imatge2	*/		"pregunta_color_primaries",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_PRIMARIES,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorTerciaries",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les terciries?",
    	/* text curt*/		"Color terciries",
    	/* imatge	*/		"pregunta_color_terciaries",
    	/* imatge2	*/		"pregunta_color_terciaries",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_TERCIARIES,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorCarpo",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t el carp",
    	/* text curt*/		"Color carp",
    	/* imatge	*/		"pregunta_color_carpo",
    	/* imatge2	*/		"pregunta_color_carpo",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_CARPO,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorSupracobertores",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les supracobertores?",
    	/* text curt*/		"Color supracobertores",
    	/* imatge	*/		"pregunta_color_supracobertores",
    	/* imatge2	*/		"pregunta_color_supracobertores",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_SUPRACOBERTORES,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorRectriusCentrals",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les rectrius centrals?",
    	/* text curt*/		"Color rectrius centrals",
    	/* imatge	*/		"pregunta_color_rectrius_centrals",
    	/* imatge2	*/		"pregunta_color_rectrius_centrals",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_RECTRIUS_CENTRALS,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorRectriusExternes",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les rectrius externes?",
    	/* text curt*/		"Color rectrius externes",
    	/* imatge	*/		"pregunta_color_rectrius_externes",
    	/* imatge2	*/		"pregunta_color_rectrius_externes",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_RECTRIUS_EXTERNES,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorInfracobertores",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t les infracobertores?",
    	/* text curt*/		"Color infracobertores",
    	/* imatge	*/		"pregunta_color_infracobertores",
    	/* imatge2	*/		"pregunta_color_infracobertores",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_INFRACOBERTORES,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorRegioAnal",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t la regio anal?",
    	/* text curt*/		"Color regi anal",
    	/* imatge	*/		"pregunta_color_regio_anal",
    	/* imatge2	*/		"pregunta_color_regio_anal",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_REGIO_ANAL,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorRegioVentral",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t la regio ventral?",
    	/* text curt*/		"Color regi ventral",
    	/* imatge	*/		"pregunta_color_regio_ventral",
    	/* imatge2	*/		"pregunta_color_regio_ventral",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_REGIO_VENTRAL,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorFlancs",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t els flancs?",
    	/* text curt*/		"Color flancs",
    	/* imatge	*/		"pregunta_color_flancs",
    	/* imatge2	*/		"pregunta_color_flancs",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_FLANCS,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorPit",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t el pit?",
    	/* text curt*/		"Color pit",
    	/* imatge	*/		"pregunta_color_pit",
    	/* imatge2	*/		"pregunta_color_pit",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_PIT,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorGola",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t la gola?",
    	/* text curt*/		"Color gola",
    	/* imatge	*/		"pregunta_color_gola",
    	/* imatge2	*/		"pregunta_color_gola",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_GOLA,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"colorSubbigotera",
    	/* activa 	*/		true, 
    	/* text 	*/		"De quin color t la subbigotera?",
    	/* text curt*/		"Color subbigotera",
    	/* imatge	*/		"pregunta_color_subbigotera",
    	/* imatge2	*/		"pregunta_color_subbigotera",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_COLOR_SUBBIGOTERA,
    	/* opcions	*/		"opcionsColor",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		100
		));
    	p.add(new pregunta(
    	/* nom 		*/		"formaColl",
    	/* activa 	*/		true, 
    	/* text 	*/		"Quina forma t el coll?",
    	/* text curt*/		"Forma coll",
    	/* imatge	*/		"pregunta_forma_coll",
    	/* imatge2	*/		"pregunta_forma_coll",
    	/* key DB	*/		dbDadesOcellAdapter.KEY_FORMA_COLL,
    	/* opcions	*/		"opcionsFormaColl",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.CONCRETA,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"habitat",
    	/* activa 	*/		true,
    	/* text 	*/		"En quin habitat has vist l'ocell?",
    	/* text curt*/		"Habitat",
    	/* imatge	*/		null,
    	/* imatge2	*/		"pregunta_habitat",
    	/* key DB	*/		null,
    	/* opcions	*/		"opcionsHabitatPerMostrar",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.HABITAT,
		/* pes		*/		200
		));
    	p.add(new pregunta(
    	/* nom 		*/		"prioritat",
    	/* activa 	*/		false, //La iniciem per un altre metode
    	/* text 	*/		null,
    	/* text curt*/		null,
    	/* imatge	*/		null,
    	/* imatge2	*/		null,
    	/* key DB	*/		dbDadesOcellAdapter.KEY_PRIORITAT,
    	/* opcions	*/		null,
    	/* dependen.*/		null,
    	/* ordre min*/		5,
		/* tipus	*/		pregunta.PRIORITAT,
		/* pes		*/		null
		));
    	p.add(new pregunta(
    	/* nom 		*/		"caracteristicaUnica",
    	/* activa 	*/		true, 
    	/* text 	*/		null,
    	/* text curt*/		null,
    	/* imatge	*/		null,
    	/* imatge2	*/		null,
    	/* key DB	*/		dbDadesOcellAdapter.KEY_CARACTERISTICA_UNICA,
    	/* opcions	*/		"opcionsCaracteristicaUnica",
    	/* dependen.*/		null,
    	/* ordre min*/		7,
		/* tipus	*/		pregunta.CARACTERISTICA,
		/* pes		*/		500
		));
    	p.add(new pregunta(
    	/* nom 		*/		"preguntaXorra",
    	/* activa 	*/		false, 
    	/* text 	*/		"Pots llegir la desena filera de lletres?",
    	/* text curt*/		null,
    	/* imatge	*/		"pregunta_xorra",
    	/* imatge	*/		null,
    	/* key DB	*/		null,
    	/* opcions	*/		"opcionsPreguntaXorra",
    	/* dependen.*/		null,
    	/* ordre min*/		0,
		/* tipus	*/		pregunta.XORRA,
		/* pes		*/		0
		));
    	return p;
    }
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	//     OPCIONS                                                                                          //
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public static ArrayList<opcions> carregaOpcions(){
    	ArrayList<opcions> o = new ArrayList<opcions>();
    	
     	// Opcions per al tamany de l'espcie /////////////////////////////////////////////
    	o.add(new opcions("opcionsTamanyCodi",
    			new String[]{
    				"1",
    				"2",
    				"3",
    				"4",
    				"5",
    				"6",
    				"7",
    				"8",
    				"9",
    				"10",
    			},
    			new String[]{
	    			"opcions_tamany_codi_1",
	    			"opcions_tamany_codi_2",
	    			"opcions_tamany_codi_3",
	    			"opcions_tamany_codi_4",
	    			"opcions_tamany_codi_5",
	    			"opcions_tamany_codi_6",
	    			"opcions_tamany_codi_7",
	    			"opcions_tamany_codi_8",
	    			"opcions_tamany_codi_9",
	    			"opcions_tamany_codi_10",
    			},
    			new String[]{
	    			"< 13,5cm.",
	    			"13,6 a 17cm.",
	    			"17 a 22cm.",
	    			"22 a 29cm.",
	    			"29 a 36cm.",
	    			"36 a 45cm.",
	    			"45 a 57cm.",
	    			"57 a 75cm.",
	    			"75 a 110cm.",
	    			"> 110cm.",
				},
    			new Integer[][]{
    				{100},
    				{90,	100},
    				{50,	90,		100},
    				{20,	50,		90,		100},
    				{7,		20,		50,		90,		100},
    				{0,		7,		20,		50,		90 ,	100},
    				{0,		0,		7,		20,		50,		90,		100},
    				{0,		0,		0,		7,		20,		50,		90,		100},
    				{0,		0,		0,		0,		7,		20,		50,		90,		100},
    				{0,		0,		0,		0,		0,		7,		20,		50,		90,		100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions per a la llargada del bec ////////////////////////////////////////////////
    	o.add(new opcions("opcionsBecLlargada",
    			new String[]{
    				"1",	/* < 1/3 de cap */
    				"2",	/* de 1/3 a 1/2 de cap */
    				"3",	/* de 1/2 a mida cap */
    				"4",	/* de 1 a 2 caps */
    				"5",	/* > 2 caps */
    			},
    			new String[]{
    				"opcions_bec_llargada_1",
    				"opcions_bec_llargada_2",
    				"opcions_bec_llargada_3",
    				"opcions_bec_llargada_4",
    				"opcions_bec_llargada_5",
    			},
    			new String[]{
					"< 1/3 del cap",
					"de 1/3 a 1/2 cap",
					"de 1/2 a 1 cap",
					"de 1 a 2 caps",
					"> 2 caps.",
				},
    			new Integer[][]{
    				{100},
    				{80,	100},
    				{40,	80,		100},
    				{10,	40,		80,		100},
    				{0,		10,		40,		80,		100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	
    	// Opcions per a la forma del bec //////////////////////////////////////////////////
    	o.add(new opcions("opcionsBecForma",
    			new String[]{
    				"cm", 	// corvat amunt
    				"cv", 	// corvat avall
    				"x", 	// creuat
    				"ad", 	// Asimtric ms gran a dalt (lloro)
    				"ab", 	// Asimtric mes gran a baix
    				"s",  	// Simtric
    			},
    			new String[]{
    				"opcions_bec_forma_cm",
    				"opcions_bec_forma_cv",
    				"opcions_bec_forma_x",
    				"opcions_bec_forma_ad",
    				"opcions_bec_forma_ab",
    				"opcions_bec_forma_s",
    			},
    			new String[]{
					"corvat amunt",
					"corvat avall",
					"creuat",
					"tipus lloro",
					"ms gran per baix",
					"simtric",
				},
    			new Integer[][]{
    				{100},
    				{0,		100},
    				{30,	50,		100},
    				{0,		70,		30,		100},
    				{20,	10,		30,		0,		100},
    				{40,	50,		70,		10,		30,		100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions per a la doblada del bec //////////////////////////////////////////////////
    	o.add(new opcions("opcionsBecDoblada",
    			new String[]{
    				"f", 	// f
    				"g", 	// gruixut (llargada i amplada a la base molt semblants)
    				"mg", 	// molt gruixut
    			},
    			new String[]{
    				"opcions_bec_doblada_f",
    				"opcions_bec_doblada_g",
    				"opcions_bec_doblada_mg",
    			},
    			new String[]{
					"f",
					"gruixut",
					"molt gruixut",
				},
    			new Integer[][]{
    				{100},
    				{50,	100},
    				{0,		50,		100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions color /////////////////////////////////////////////////////////////////
    	o.add(new opcions("opcionsColor",
    			new String[]{
    				"n", 	// negre
    				"gf", 	// gris fosc
    				"gc", 	// gris clar
    				"mf", 	// marr fosc
    				"mc", 	// marr clar
    				"rg", 	// roig
    				"t", 	// teula
    				"c", 	// carabassa
    				"g", 	// groc
    				"v", 	// vins
    				"r", 	// rosa
    				"b", 	// blanc
    				"bl", 	// blau
    				"ve", 	// verd
    			},
    			new String[]{
    				"opcions_color_n",
    				"opcions_color_gf",
    				"opcions_color_gc",
    				"opcions_color_mf",
    				"opcions_color_mc",
    				"opcions_color_rg",
    				"opcions_color_t",
    				"opcions_color_c",
    				"opcions_color_g",
    				"opcions_color_v",
    				"opcions_color_r",
    				"opcions_color_b",
    				"opcions_color_bl",
    				"opcions_color_ve",
    			},
    			new String[]{
					"negre",
					"gris fosc",
					"gris clar",
					"marr fosc",
					"marr clar",
					"roig",
					"teula",
					"carbassa",
					"grog",
					"vinos",
					"rosa",
					"blanc",
					"blau",
					"verd",
				},
    			new Integer[][]{
	    		/* n */		{100},
	    		/* gf*/		{80,	100},
	    		/* gc*/		{15,	60,		100},
	    		/* mf*/		{35,	75,		40,		100},
	    		/* mc*/		{5,		35,		75,		75,		100},
	    		/* rg*/		{0,		5,		0,		20,		15,		100},
	    		/* t*/		{15,	10,		0,		50,		15,		80,		100},
	    		/* c*/		{0,		5,		10,		30,		75,		50,		20,		100},
	    		/* g*/		{0,		5,		0,		10,		30,		0,		0,		50,		100},
	    		/* v*/		{25,	0,		0,		35,		10,		45,		80,		25,		0,		100},
	    		/* r*/		{0,		15,		20,		15,		25,		25,		45,		12,		0,		85, 	100},
	    		/* b*/		{0,		0,		75,		0,		45,		0,		0,		15,		20,		5,		15,		100},
	    		/* bl*/		{15,	5,		0,		0,		0,		0,		15,		0,		0,		25, 	0,		0,		100},
	    		/* ve*/		{0,		5,		0,		5,		0,		0,		0,		0,		0,		0, 		0,		0,		20,		100}},
	    		/*			n		gf		gc		mf		mc		rg		t		c		g		v		r		b		bl		ve*/
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions per a la proporcio de les potes //////////////////////////////////////////////////
    	o.add(new opcions("opcionsPotesProporcio",
    			new String[]{
    				"m", 	// molt llargues
    				"ll", 	// llargues
    				"c", 	// compensades
    				"p", 	// curtes
    			},
    			new String[]{
    				"opcions_potes_proporcio_m",
    				"opcions_potes_proporcio_ll",
    				"opcions_potes_proporcio_c",
    				"opcions_potes_proporcio_p",
    			},
    			new String[]{
					"molt llargues",
					"llargues",
					"compensades",
					"curtes",
				},
    			new Integer[][]{
    				{100},
    				{70,	100},
    				{5,		45,		100},
    				{0,		5,		75, 	100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions per a la llargada de la cua //////////////////////////////////////////////////
    	o.add(new opcions("opcionsCuaForma",
    			new String[]{
    				"p", 	// petita
    				"c", 	// compensada
    				"ll", 	// llarga
    			},
    			new String[]{
    				"opcions_cua_forma_p",
    				"opcions_cua_forma_c",
    				"opcions_cua_forma_ll",
    			},
    			new String[]{
					"petita",
					"compensada",
					"llarga",
				},
    			new Integer[][]{
    				{100},
    				{60,	100},
    				{0,		60,		100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions de fenologia ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsFenologia",
    			new String[]{
    				"2",
    				"1",
    				"0",
    			},
    			new String[]{
    				null,
    				null,
    				null,
    			},
    			new String[]{
					null,
					null,
					null,
				},
    			new Integer[][]{
    				{100},
    				{50,	100},
    				{8,		50,		100}},
    			null
    			));
    	// Opcions de fenologia als filtres ////////////////////////////////////////
    	o.add(new opcions("opcionsFenologiaMostrarFiltres",
    			new String[]{
    				"2",
    			},
    			new String[]{
    				"pregunta_fenologia",
    			},
    			new String[]{
					"filtrar per fenologia",
				},
    			new Integer[][]{},
    			null
    			));
    	// Opcions de raresa ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsRaresa",
    			new String[]{
    				"",
    				"r",
    				"a",
    			},
    			new String[]{
    				"opcions_raresa_normal",
    				"opcions_raresa_rar",
    				"opcions_raresa_accidental",
    			},
    			new String[]{
					"normal",
					"rar",
					"accidental",
				},
    			new Integer[][]{
    				{100},
    				{50,	100},
    				{5,		50,		100}},
    			null
    			));
    	// Opcions sobre els aspectesde pigmentacio //////////////////////////////////////
    	o.add(new opcions("opcionsAspecte",
    			new String[]{
    				"d",	/* colors clarament delimitats */
    				"p",	/* pigmentat */
    				"r",	/* ratllat */
    			},
    			new String[]{
					"opcions_aspecte_d",
					"opcions_aspecte_p",
					"opcions_aspecte_r",
				},
				new String[]{
					"ntid",
					"pigmentat",
					"ratllat",
				},
				new Integer[][]{
					{100},
					{0,		100},
					{0,		60,		100}},
				new String[]{
					SENSE_RESPOSTA,
					"opcions_sense_resposta",
					"no ho s",
				}
    			));
    	// Opcions sobre si t cresta  ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsTeCresta",
    			new String[]{
    				"s",	
    				"n",	
    			},
    			new String[]{
					"opcions_si",
					"opcions_no",
				},
				new String[]{
					"si",
					"no",
				},
				new Integer[][]{
					{100},
					{5,		100}},
				new String[]{
					SENSE_RESPOSTA,
					"opcions_sense_resposta",
					"no ho s",
				}
    			));
    	// Opcions sobre si te linia a l'ala ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsTeLiniaAla",
    			new String[]{
    				"s",	
    				"n",	
    			},
    			new String[]{
					"opcions_si",
					"opcions_no",
				},
				new String[]{
					"si",
					"no",
				},
				new Integer[][]{
					{100},
					{5,		100}},
				new String[]{
					SENSE_RESPOSTA,
					"opcions_sense_resposta",
					"no ho s",
				}
    			));
    	// Opcions de forma de coll ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsFormaColl",
    			new String[]{
    				"f",	/* molt empegat al cos (fernando alonso)*/
    				"m",	/* mitja */
    				"b",	/* estirat */
    				"s",	/* molt estirat */
    			},
    			new String[]{
					"opcions_forma_coll_f",
					"opcions_forma_coll_m",
					"opcions_forma_coll_b",
					"opcions_forma_coll_s",
				},
				new String[]{
					"molt curt",
					"mitj",
					"estirat",
					"molt estirat",
				},
				new Integer[][]{
					{100},
					{60,	100},
					{0,		60,		100},
					{0,		0,		60,		100}},
				new String[]{
					SENSE_RESPOSTA,
					"opcions_sense_resposta",
					"no ho s",
				}
    			));
    	// Opcions d'habitat per mostrar///////////////////////////////////////////////
    	o.add(new opcions("opcionsHabitatPerMostrar",
    			new String[]{ //desem al codi de les opcions el mateix camp de la BBDD
    				dbDadesOcellAdapter.KEY_HABITAT_AIGUAMOLLS,
    				dbDadesOcellAdapter.KEY_HABITAT_BOSC_RIBERA,
    				dbDadesOcellAdapter.KEY_HABITAT_SECA,
    				dbDadesOcellAdapter.KEY_HABITAT_COSTA,
    				dbDadesOcellAdapter.KEY_HABITAT_BOSC,
    				dbDadesOcellAdapter.KEY_HABITAT_PRATS_ALPINS,
    				dbDadesOcellAdapter.KEY_HABITAT_MAR,
    				dbDadesOcellAdapter.KEY_HABITAT_CULTIU_SECA,
    				dbDadesOcellAdapter.KEY_HABITAT_CULTIU_REGADIU,
    				dbDadesOcellAdapter.KEY_HABITAT_RUPESTRE
    			},
    			new String[]{
	    			"opcions_habitat_aiguamolls",
	    			"opcions_habitat_bosc_ribera",
	    			"opcions_habitat_seca",
	    			"opcions_habitat_costa",
	    			"opcions_habitat_bosc",
	    			"opcions_habitat_prats_alpins",
	    			"opcions_habitat_mar",
	    			"opcions_habitat_cultiu_seca",
	    			"opcions_habitat_cultiu_regadiu",
	    			"opcions_habitat_rupestre",
    			},
    			new String[]{
    				"aiguamolls",
    				"bosc ribera",
    				"seca",
    				"costa",
	    			"bosc",
	    			"prats alpins",
	    			"mar",
	    			"cultiu seca",
	    			"cultiu regadiu",
	    			"rupestre",
				},
    			new Integer[][]{
    				null},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
			}
    			));
    	// Opcions habitat per als calculs  ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsHabitatPerCalcul",
    			new String[]{
    				"2",
    				"1",
    				"0",
    			},
    			new String[]{
    				null,
    				null,
    				null,
    			},
    			new String[]{
					null,
					null,
					null,
    			},
    			new Integer[][]{
    				{100},
    				{50,	100},
    				{0,		50,		100}},
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
				}
    			));
    	// Opcions per a caracterstica nica  ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsCaracteristicaUnica",
    			new String[]{
    				"si",
    				"no",
    			},
    			new String[]{
    				"opcions_si",
    				"opcions_no",
    			},
    			new String[]{
					null,
					null,
				},
    			new Integer[][]{
    				{100}}, //percentatge que afegira o treura
    			new String[]{
    				SENSE_RESPOSTA,
    				"opcions_sense_resposta",
    				"no ho s",
				}
    			));
    	// Opcions sobre si te linia a l'ala ///////////////////////////////////////////////////
    	o.add(new opcions("opcionsPreguntaXorra",
    			new String[]{
    				"s",	
    				"n",	
    			},
    			new String[]{
					"opcions_si",
					"opcions_no",
				},
				new String[]{
					"si",
					"no",
				},
				new Integer[][]{
					{0},
					{0,	0}},
				new String[]{
					SENSE_RESPOSTA,
					"opcions_sense_resposta",
					"no ho s",
				}
    			));
    	
    	return o;
	}	
}