package catalunya.de.ocells.cerca;

import java.util.ArrayList;

import android.util.Log;
import catalunya.de.ocells.db.dbDadesOcellAdapter;

/**
 * Classe opcions
 * @author jsirera
 *
 */

public class opcions {
	
	public final static Integer CODI = 0;
	public final static Integer RECURS = 1;
	public final static Integer TEXT = 2;

	
	public String 		nom;
	public String[] 	codiOpcio;
	public String[] 	recurs;
	public String[] 	text;
	public Integer[][]	relacions;
	public String[]		senseResposta;
    
	/**
	 * COnstrucci d'opcions
	 * @param nom Nom de l'opcio
	 * @param codiOpcio Codis de les opcions
	 * @param recurs Texts o imatges de la opcio
	 * @param relacions Relacions en percentatge entre totes les possibles respostes
	 * @param senseResposta Codi i recurs de l'opci quan no es vulgui contestar
	 */
    public opcions(String nom, String[] codiOpcio, String[] recurs, String[] text, Integer[][] relacions, String[] senseResposta) {
    	this.nom = nom;
    	this.codiOpcio = codiOpcio;
    	this.recurs = recurs;
    	this.text = text;
    	this.relacions = relacions;
    	this.senseResposta = senseResposta;
    }
    
    
    /**
     * Retorna el id d'una opcio a partir del codi d'opcio
     * @param codi_opcio codid de l'opci
     * @return id de l'opcio
     */
  	public Integer getIdOpcio(String codi_opcio){
  		boolean trobat = false;
  		Integer idOpcio = 0;
  		for (int i=0; i < codiOpcio.length && !trobat ; i++){
  			if (codiOpcio[i].compareTo(codi_opcio)==0){
  				idOpcio = i;
  				trobat = true;
  			}
  		}
  		if (!trobat) Log.e("ocells", "opcions.java (getIdOpcio): No s'han trobat el codi d'opcio: " + codi_opcio);
		return idOpcio;
  	}

	
	/**
	 * Cerca la relaci entre dos respostes, per exemple color gris fosc amb color gris clar.
	 * @param id_codi_opcio_resposta
	 * @param id_codi_opcio_valorar
	 * @return retorna la relaci de similitud entre les dues opcions
	 */
	public double cercaRelacio(Integer id_codi_opcio_resposta, Integer id_codi_opcio_valorar){
		double relacio = defs.NO; 
		if (id_codi_opcio_resposta >= id_codi_opcio_valorar)
			relacio = relacions[id_codi_opcio_resposta][id_codi_opcio_valorar];
		else
			relacio = relacions[id_codi_opcio_valorar][id_codi_opcio_resposta];
		if (relacio==defs.NO) Log.e("ocells", "opcions.java (cercaRelacio): No s'han trobat la relacio entre les opcions: " + id_codi_opcio_resposta + " i " + id_codi_opcio_valorar);
		return relacio;
	}
}
